/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.runtime;

public class CRChangeEvent  {
	
	public static final int CONNECTOR_ADDED=0;
	public static final int CONNECTOR_REMOVED=1;
	public static final int PROPERTY_CHANGE=2;
	public static final int COMBSTRAT_ADDED=3;
	public static final int COMBSTRAT_REMOVED=4;
	public static final int ALLCHANGE=5;
	
	private int type = -1;
	private Object param;
	private PropChange propChange;
	
	public static enum PropChange {ENABLED,DISABLED,SETSTATIC,SETNONSTATIC,NONE};
	 
	CRChangeEvent(int type,Object param)  {
		this(type,param,PropChange.NONE);
	}
	
	CRChangeEvent(int type)  {
		
		this(type,null);
	}
	
	CRChangeEvent(int type,Object param,PropChange prop)  {
		
		this.type=type;
		this.param=param;
		this.propChange=prop;
	}
	
	public int getType()  {
		return type;
	}
	
	public Object getParam()  {
		return param;
	}
	
	public PropChange getPropertyChange() {
		
		return propChange;
	}
}