/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.runtime;

import jasco.runtime.connector.CutpointExecutionElement;
import jasco.runtime.connector.HookElement;

public class CutpointAfterComparator implements MyComparator 
{

	public int compare(Object object1, Object object2)
	{
		HookElement c1 = (HookElement)object1;
		HookElement c2 = (HookElement)object2;
		
		CutpointExecutionElement ce1 = c1.getAfter();
		CutpointExecutionElement ce2 = c2.getAfter();
		
		if (ce1.getExecutionNumber() < ce2.getExecutionNumber())
		{
			return -1;
		}
		else 
		{
			if (ce1.getExecutionNumber() > ce2.getExecutionNumber()) 
			{
				return 1;
			}
			else 
			{
				return 0;
			}
		}
	}
}
	
	
	
		
		
