package jasco.runtime;

import jasco.runtime.aspect.HookHelper;
import jasco.runtime.aspect.IHook;
import jasco.runtime.aspect.PCutpointConstructorRegular;
import jasco.runtime.aspect.StatefulAspect;
import jasco.runtime.connector.HookElement;

import java.util.Iterator;
import java.util.Vector;
import java.util.Map.Entry;

public class JAsCoJPInterpreter {
	
	public static Object executeHooks(java.util.Vector hooks, JascoMethod originalMethod, boolean executeOriginal) throws java.lang.Exception {
		
		originalMethod=originalMethod.copy();
		Object output = null;
		java.util.Hashtable<StatefulAspect,Integer> hasherStateful = new java.util.Hashtable<StatefulAspect,Integer>();
		VectorSorter.sort(hooks,new CutpointReplaceComparator());
		
		Vector linkedHooks = new Vector();
		for (int i = 0; i < hooks.size() ; ++i) {
			HookElement cutpointElement = (HookElement)hooks.elementAt(i);
			IHook cp = cutpointElement.getCutpoint();
			if(cutpointElement.getReplace().getExecution()) {
				linkedHooks.add(cutpointElement.getCutpoint());
			}
			if(cp instanceof StatefulAspect) {
				StatefulAspect cpa = (StatefulAspect)cp;
				PCutpointConstructorRegular reg = (PCutpointConstructorRegular) cp._Jasco_getConstructorRep();
				hasherStateful.put(cpa,cpa._jasco_setStatefulAspectState(reg.getCurrentStateID()));

			}
		}
		IHook[] linkedHooksArray = new IHook[linkedHooks.size()];
		linkedHooks.toArray(linkedHooksArray);
		Vector aroundThrowing = new Vector();
		Vector aroundReturning = new Vector();
		for(int i=0;i<linkedHooksArray.length;++i) {
			IHook cp = linkedHooksArray[i];
			if(HookHelper.definesAdvice(cp,IHook.AROUND_THROWING))
					aroundThrowing.add(cp);
			if(HookHelper.definesAdvice(cp,IHook.AROUND_RETURNING))
					aroundReturning.add(cp);
		}
		
		VectorSorter.sort(hooks,new CutpointBeforeComparator());
		for (int i = 0; i < hooks.size() ; ++i) {
			HookElement cutpoint = (HookElement)hooks.elementAt(i);
			if(cutpoint.getBefore().getExecution()) cutpoint.getCutpoint().before(originalMethod,originalMethod.getCalledObject(),originalMethod.getArgumentsArray());
		}
		originalMethod.setLinkedHooks(linkedHooksArray);
		try {
		try {
		if(executeOriginal||linkedHooksArray.length>0)
			output = originalMethod.invokeJAsCoMethod();
		
		for (int i = aroundReturning.size()-1; i >=0 ; --i) {
			IHook cutpoint = (IHook)aroundReturning.elementAt(i);
			output = cutpoint.around_returning(output,originalMethod,originalMethod.getCalledObject(),originalMethod.getArgumentsArray());
		}
		}
		catch(Exception ex)  {
			for (int i = 0; i< aroundThrowing.size(); ++i) {
				IHook cutpoint = (IHook)aroundThrowing.elementAt(i);
				if(i==(aroundThrowing.size()-1)) //last to execute, no catch anymore...
					output = cutpoint.around_throwing(ex,originalMethod,originalMethod.getCalledObject(),originalMethod.getArgumentsArray());
				
				else {
				try {
					output = cutpoint.around_throwing(ex,originalMethod,originalMethod.getCalledObject(),originalMethod.getArgumentsArray());
					break;
				}catch(Exception ex2) {ex=ex2;}
				}
			}
			if(aroundThrowing.size()==0)
				throw(ex);
		}
		VectorSorter.sort(hooks,new CutpointAfterComparator());
		for (int i = 0; i < hooks.size() ; ++i) {
			HookElement cutpoint = (HookElement)hooks.elementAt(i);
			if(cutpoint.getAfter().getExecution()) {
				cutpoint.getCutpoint().after_returning(output,originalMethod,originalMethod.getCalledObject(),originalMethod.getArgumentsArray());
			}
		}
		}
		catch(Exception ex)  {
			VectorSorter.sort(hooks,new CutpointAfterComparator());
			for (int i = 0; i < hooks.size() ; ++i) {
				HookElement cutpoint = (HookElement)hooks.elementAt(i);
				if(cutpoint.getAfter().getExecution()) cutpoint.getCutpoint().after_throwing(ex,originalMethod,originalMethod.getCalledObject(),originalMethod.getArgumentsArray());
			}
			throw(ex);
		}
		finally {
			VectorSorter.sort(hooks,new CutpointAfterComparator());
			for (int i = 0; i < hooks.size() ; ++i) {
				HookElement cutpoint = (HookElement)hooks.elementAt(i);
				if(cutpoint.getAfter().getExecution()) {
					cutpoint.getCutpoint().after(originalMethod,originalMethod.getCalledObject(),originalMethod.getArgumentsArray());
				}
			}
			Iterator<Entry<StatefulAspect,Integer>> i = hasherStateful.entrySet().iterator();
			while(i.hasNext()) {
				Entry<StatefulAspect,Integer> entry = i.next();
				entry.getKey()._jasco_setStatefulAspectState(entry.getValue());
			}
		}
		return output;
	}

	public static Object executeHooks(Vector result, JascoMethod jascoMethod) throws Exception {
		return executeHooks(result,jascoMethod,true);
	}

}
