/*
 * Created on 14-mrt-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jasco.runtime.aspect;

import jasco.runtime.JascoMethod;
import jasco.runtime.MethodJoinpoint;
import jasco.tools.aspectparser.AspectClassesGenerator;
import jasco.util.logging.Logger;

import java.util.Hashtable;

import javassist.NotFoundException;

/* 
 Copyright (C) 2002-2005 JAsCo Development Team
 http://ssel.vub.ac.be/jasco
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as
 published by the Free Software Foundation; either version 2 of the
 License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 USA 
 */

/**
 * @author Wim
 */

public class PCutpointConstructorArgs extends
		PCutpointConstructorApplicationDesignator {

	private ConstructorMethod method;
	private int sourceId;
	
	public PCutpointConstructorArgs(
			ConstructorMethod method, int id) {
		super(null);
		this.method=method;
		this.sourceId=id;
	}

	
	/* (non-Javadoc)
	 * @see jasco.runtime.aspect.PCutpointConstructorApplicationDesignator#eval(jasco.runtime.RuntimeContext, java.util.Hashtable, boolean)
	 */
	public boolean eval(MethodJoinpoint jp, Hashtable mappings,
			boolean forJutta) {
		
		if(!(jp instanceof JascoMethod)) //e.g. DummyMixinJP
			return true;
		
		JascoMethod jascojp = (JascoMethod) jp; 
		
		if(!method.isCompatibleReturnJavassist(jascojp))
			return false;

		try {
			if(!method.isCompatibleArgsJavassist(jascojp.getJavassistMethod().getParameterTypes()))
				return false;
		} catch (NotFoundException e) {
			Logger.getInstance().showError(e);return false;
		}
		 
		return true;
	}

	public String generateCreateCode(String argname) {
		return argname+" = new PCutpointConstructorArgs("+AspectClassesGenerator.CONSTRUCTOR_ARGS+"["+sourceId+"], "+sourceId+");"+NEWLINE;
	}

	/* (non-Javadoc)
	 * @see jasco.runtime.aspect.PCutpointConstructorApplicationDesignator#toDescString()
	 */
	public String toDescString() {
		return "no desc";
	}

}
