/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
/*
 * Created on 12-nov-2004
 */
package jasco.runtime.aspect;

import jasco.runtime.MethodJoinpoint;

import java.util.Hashtable;
import java.util.Vector;

/**
 * @author Wim
 */
public class PCutpointConstructorComplement extends PCutpointConstructorRegular {
	
	public static final String COMPLEMENT_NAME = "complement";
	private PCutpointConstructorApplicationDesignator complementSet;
	private int currentStateId = -1;
	
	public PCutpointConstructorComplement(PCutpointConstructorApplicationDesignator complementSet) {
		super();
		
		this.complementSet=complementSet;
	}
	
	public Vector allPointcuts() {
		
		Vector v = super.allPointcuts();
		v.add(complementSet);
		return v;
	}
	
	public String generateClassCreateCode(String argname) {
		
		String code = "";
		String param = getNextArgName();
		code+="PCutpointConstructorApplicationDesignator "+param+" = null;"+NEWLINE;
		
		String complementCode = complementSet.generateCreateCode(param);
		code+=complementCode;
		
		code+=argname+"= new PCutpointConstructorComplement("+param+");"+NEWLINE;
		 
		return code;
	}
	
	public boolean eval(MethodJoinpoint jp,Hashtable mappings,boolean forJutta)  {
		
		boolean complementEval = complementSet.eval(jp,mappings,forJutta);
		
		if(complementEval) {
			boolean regEval = super.eval(jp,mappings,forJutta);
			if(!forJutta) {
				if(regEval)
					currentStateId=super.getCurrentStateID();
				else currentStateId=State.COMPLEMENT;
			}
			return true;
		}
		else return false;
	}
	
	public int getCurrentStateID() {
		
		return currentStateId;
	}
	
	public boolean definesName(String name) {
		
		if(name.equals(COMPLEMENT_NAME))
			return true;
		else return super.definesName(name);
	}

}
