/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.runtime.aspect;

import jasco.runtime.MethodJoinpoint;
import jasco.runtime.connector.ISignatureMatcher;

import java.util.Hashtable;

public class PCutpointConstructorExecute extends PCutpointConstructorApplicationDesignator
{	
	private String method;
	
	private boolean fix = false; 
		
	public PCutpointConstructorExecute(String method, boolean fix)  {
	
		super(null);
		
		this.method=method; 
		this.fix=fix;
	}
	
	public String getCalledMethod()  {
	
		return method;
	}
	
	public boolean eval(MethodJoinpoint jp, Hashtable mappings, boolean forJutta)  {
		
		
		//System.out.println("----------------------");
		//System.out.println(mappings.toString());
		//System.out.println("Context"+method.toString());
		boolean res=true;
		
		ISignatureMatcher sig = (ISignatureMatcher) mappings.get(method);
		
		res = res&&jp.isExecution();
		
		res=res&&sig.matchesJoinpoint(jp);
		
		//System.out.println(res);
		//System.out.println("m is "+sig);
		return res;
		
	}
	
	public String generateCreateCode(String argname)  {
		
		String code =argname+" = new PCutpointConstructorExecute(\""+method+"\", "+fix+");"+NEWLINE;
		return code;
	}
	
	public String toDescString()  {
	
		return "execution("+getNextArgName()+")";
	}
}