package jasco.runtime.aspect;

import jasco.runtime.MethodJoinpoint;
import jasco.runtime.distribution.DistributedJascoMethod;
import jasco.util.generators.JavaGenerator;
import jasco.util.logging.Logger;

import java.util.Hashtable;

public class PCutpointConstructorExecutionEqualsJoinpointHost extends
		PCutpointConstructorApplicationDesignator {

	public PCutpointConstructorExecutionEqualsJoinpointHost() {
		super(null);
	}

	@Override
	public boolean eval(MethodJoinpoint jp, Hashtable mappings, boolean forJutta) {

		if(!(jp instanceof DistributedJascoMethod)) {
			Logger.getInstance().showError("Distribution pointcut phost, but non distributed deployment! "+jp.getSignature());
			return false;
		}
		
		DistributedJascoMethod djp  = (DistributedJascoMethod) jp;
		
		return djp.getHost() == null || djp.getHost().isLocalHost(); //null means local host as well
	}

	@Override
	public String generateCreateCode(String argname) {
		
		return argname+" = new PCutpointConstructorExecutionEqualsJoinpointHost();"+JavaGenerator.NEWLINE;
	}

	@Override
	public String toDescString() {
		return "executionhost(joinpointhost)";
	}

}
