package jasco.runtime.aspect.factory;

import java.util.Map;
import java.util.Hashtable;
import junit.framework.TestCase;

/**
 * These unit tests embody some assumptions of the PerBindingAspectFactory class
 */
public class AspectHashTest extends TestCase {

	private Map t1;
	private Map t2;
	private Map t3;

	public void setUp() {
		t1 = new Hashtable();
		t1.put("aa", "foo");
		t1.put("bb", "bar");
		t2 = new Hashtable();
		t2.put("aa", "foo");
		t2.put("bb", "bar");
		t3 = new Hashtable();
		t3.put("aa", "bar");
		t3.put("bb", "foo");
	}
	
	public void tearDown() {
		t1 = null;
		t2 = null;
		t3 = null;
	}

	public void testMapEquals() {
		assertTrue(t1.equals(t2));
		assertFalse(t3.equals(t1));
	}
	
	public void testMapMap() {
		Object id1 = new Object();
		Object id2 = new Object();
		assertFalse(id1 == id2);
		Map testmap = new Hashtable();
		testmap.put(t1,id1);
		assertTrue(testmap.get(t2) == id1);
		testmap.put(t2,id2);
		assertTrue(testmap.get(t1) == id2);
	}
}