/*
 * Created on 25-mrt-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jasco.runtime.aspect.factory;

import jasco.runtime.DoNotCache;
import jasco.runtime.MethodJoinpoint;
import jasco.runtime.aspect.IHook;
import jasco.util.logging.Logger;

import java.util.Iterator;
import java.util.Vector;

/* 
 Copyright (C) 2002-2005 JAsCo Development Team
 http://ssel.vub.ac.be/jasco
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as
 published by the Free Software Foundation; either version 2 of the
 License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 USA 
 */

/**
 * @author Wim
 */

public class PerThreadAspectFactory implements IPredefinedAspectFactory,DoNotCache {
	
	private ThreadLocal threadLocal = null;
	
	public PerThreadAspectFactory() {
		super();
	}

	/* (non-Javadoc)
	 * @see jasco.runtime.aspect.factory.IAspectFactory#getAspectInstance(jasco.runtime.MethodJoinpoint, jasco.runtime.aspect.factory.IAspectInstanceCreator)
	 */
	public IHook getAspectInstance(MethodJoinpoint jp,
			IAspectInstanceCreator creator) {
		return getAspectInstance((Object)null, creator);
	}
	
	public IHook getAspectInstance(Object key, final IAspectInstanceCreator creator) {
		
		if(threadLocal==null) {
			
			threadLocal=new ThreadLocal() {
				protected synchronized Object initialValue() {
				
				try {
					return creator.createNewInstance();
				} catch (HookInstantiationFailed e) {
					Logger.getInstance().showError(e);
				}
				return null;
				}
			};
		}
	
		
		IHook hook =  (IHook) threadLocal.get();
		return hook;
	}
	
	public String getKeyFetchSourceCode(String jpname, MethodJoinpoint jp) {
		
		return "jasco.runtime.NULL#instance";
	}
	
	
	//TODO: finish implementation....
	public Iterator getAll() {
		
		return new Vector().iterator();
	}
}

//public class PerThreadAspectFactory extends WeakReferenceAspectFactory implements DoNotCache,IPredefinedAspectFactory {
//
//	/**
//	 * 
//	 */
//	public PerThreadAspectFactory() {
//		super();
//	}
//	
//	/* (non-Javadoc)
//	 * @see jasco.runtime.aspect.factory.DefaultAspectFactory#getKey(jasco.runtime.MethodJoinpoint)
//	 */
//	public Object getKey(MethodJoinpoint jp) {
//		return Thread.currentThread();
//	}
//	
//	public String getKeyFetchSourceCode(String jpname, MethodJoinpoint jp) {
//		
//		return "Thread.currentThread()";
//	}
//
//}
