/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.runtime.cache;

import jasco.util.generators.MethodGenerator;


public class CachedAspectRep  {

	private String name;
	private MethodGenerator constrCode;
	private MethodGenerator invokeMethod;
	private StringBuffer invokeInitCode = new StringBuffer();
	
	
	public CachedAspectRep(String name)  {
	
		this.name=name;
	}
	
	public void setConstructorCode(MethodGenerator code)  {
	
		constrCode=code;
	}
	
	public void appendToConstructorCode(String code)  {
	
		constrCode.setImplementation(constrCode.getImplementation()+code);
	}
	
	public String getConstructorCode()  {
	
		return constrCode.toString();
	}
	
	public String getInvokeCode()  {
	
		return invokeMethod.toString();
	}
	
	public MethodGenerator getInvokeMethod()  {
	
		return invokeMethod;
	}
	
	public void addInvokeInitCode(String code)  {
	
		invokeInitCode.append(code);
	}
	
	public String getInvokeInitCode()  {
	
		return invokeInitCode.toString();
	}
	
	
	public MethodGenerator getConstructorMethod()  {
	
		return constrCode;
	}
	
	public void setInvokeCode(MethodGenerator code)  {
	
		invokeMethod=code;
	} 
}