package jasco.runtime.distribution;

import jasco.runtime.JAsCoBeanCallback;
import jasco.runtime.JascoMethod;
import jasco.runtime.ReflectJascoMethod;
import jasco.runtime.transform.TransformerConstants;

import java.lang.reflect.Modifier;

import javassist.CtMethod;
import javassist.NotFoundException;

public class DistributedJascoMethod extends ReflectJascoMethod {
	
	//	LDBN 6-6-2005 introduce the host parameter, in principle will identify 
	// this node in the group created by jgroups
	private Host host;
	private boolean remoteJP = false;
	
	public DistributedJascoMethod(String fullname, String aName,
			String aClassName, int methodid, JAsCoBeanCallback callbackObject,
			int modifiers, boolean isExecution) {
		super(fullname, aName, aClassName, methodid, callbackObject, modifiers,
				isExecution);
	}
	
	public Object invokeOriginal(Object o, Object[] args) throws Exception
	{	
		if(o==null&&!Modifier.isStatic(getModifiers()))
			return null;
		else return super.invokeOriginal(o,args);
		/*
		if(host.equals(InetAddress.getLocalHost()))
			
		else return DistributedTrapExecutor.invokeProceed(this,o,args);
		*/
	}
	
	public Host getHost() {
		
		return host;
	}
	
	public void setHost(Host host) {
		
		this.host=host;
	}

	/**
	 * @return Returns the remoteJP.
	 */
	public boolean isRemoteJP() {
		return remoteJP;
	}

	/**
	 * @param remoteJP The remoteJP to set.
	 */
	public void setRemoteJP(boolean remoteJP) {
		this.remoteJP = remoteJP;
	}
	 
    public static JascoMethod buildFrom(CtMethod method,ClassLoader loader, int id) throws NotFoundException {
		
		String fullName = TransformerConstants.getFullName(method);
		
		JascoMethod theMethod = new DistributedJascoMethod(
				fullName,  
				method.getName(), 
				method.getDeclaringClass().getName(), 
				id, 
				null, 
				method.getModifiers(), 
				true);
		
		initFrom(theMethod,method,loader,id);
		
		return theMethod;
	}
}
