package jasco.runtime.distribution;

import java.util.Vector;

public class HostWrapper implements IHostSet {
	
	private Host host;
	
	private HostWrapper(Host host) {
		super();
		this.host=host;
	}

	public boolean containsLocalHost() {
		return host.isLocalHost();
	}

	public static IHostSet buildFrom(String desc) {
		
		return new HostWrapper(Host.buildFrom(desc));
	}
 
	public boolean isLocalHost() {
		return host.isLocalHost();
	}

	public boolean contains(Host host) {
		return this.host.equals(host);
	}
	
	public String toString() {
		return host.toString();
	}

	public IHostSet selectHostsByStrategy() {
		Vector<Host> v = new Vector<Host>();
		v.add(host);
		return new HostSet(v);
	}

	public Host selectOneHostByStrategy() {
		return host;
	}
}
