/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
/*
 * Created on 28-nov-2004
 */
package jasco.runtime.hotswap;

import java.lang.instrument.ClassFileTransformer;
import java.lang.instrument.IllegalClassFormatException;
import java.security.ProtectionDomain;

/**
 * @author Wim
 */
public class JavaTransformerPlugin implements ClassFileTransformer {

	/**
	 * 
	 */
	public JavaTransformerPlugin() {
		super();
		// TODO Auto-generated constructor stub
	}

	/* (non-Javadoc)
	 * @see java.lang.instrument.ClassFileTransformer#transform(java.lang.ClassLoader, java.lang.String, java.lang.Class, java.security.ProtectionDomain, byte[])
	 */
	public byte[] transform(ClassLoader arg0, String arg1, Class arg2,
			ProtectionDomain arg3, byte[] arg4)
			throws IllegalClassFormatException {
		
		if(arg0!=null&&arg0!=ClassLoader.getSystemClassLoader()) {
			try {
			Class transformer = arg0.loadClass("jasco.runtime.hotswap.JAsCoTransformer");
			Object transformerO = transformer.newInstance();
			
			java.lang.reflect.Method m =  transformer.getMethod("transform",new Class[] {ClassLoader.class,String.class,Class.class,ProtectionDomain.class,byte[].class});
			return (byte[]) m.invoke(transformerO,new Object[] {arg0,arg1,arg2,arg3,arg4});
			}
			catch(Exception ex) {
				ex.printStackTrace();
				return JAsCoHotSwap.getTransformer().transform(arg0,arg1,arg2,arg3,arg4);
			}
		}
		else return JAsCoHotSwap.getTransformer().transform(arg0,arg1,arg2,arg3,arg4);
	}
}
