/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
/*
 * Created on 20-okt-2004
 */
package jasco.testing;

import jasco.options.Options;

import java.io.File;

/**
 * @author Wim
 */
public abstract class CompileTest extends DefaultJAsCoTest {

	private String filename;
	
	public CompileTest(String filename, String command) {
		super("no descrption", command);
		
		String output = getOutputDir();
		String classpath = output+Options.PATH_SEPARATOR+ new File(getWorkingDir(),"classes").getAbsolutePath()
			+Options.PATH_SEPARATOR+new File(getWorkingDir(),"testing-libs.jar").getAbsolutePath();
		addOption("\"-outputdir:"+output+"\"");
		addOption("\"-classpath:"+classpath+"\"");
		addOption("-k");
		
		setFileName(filename);
	}
	
	public void setTarget(String target) {
		
		addOption("-target:"+target);
	}
	
	public void setFileName(String s) {
		
		File f = new File(getWorkingDir(),s);
		if(!f.exists())
			logGlobalError("file does no exist: "+s);
		
		this.filename=f.getAbsolutePath();
		
		addOption("\""+filename+"\"");
		
		setDescription("compiling "+getTargetName()+" "+f.getName());
	}
	
	public abstract String getTargetName();
}