/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
/*
 * Created on 20-okt-2004
 */
package jasco.testing;

import jasco.util.StreamGobbler;
import jasco.util.generators.JavaGenerator;
import jasco.util.logging.Logger;

import java.io.InputStream;
import java.io.Writer;

/**
 * @author Wim
 */
public class JAsCoTestStreamGobbler extends StreamGobbler {
	
	private StringBuffer resultBuffer;
	private Writer resultStream;
	
	public JAsCoTestStreamGobbler(InputStream is, String type, StringBuffer resultBuffer, Writer resultStream) {
		super(is,type,false);
		this.resultBuffer=resultBuffer;
		this.resultStream=resultStream;
	}
	
	/* (non-Javadoc)
	 * @see jasco.util.StreamGobbler#showOutput(java.lang.String)
	 */
	public void showOutput(String s) {
		
		resultBuffer.append(s);
		try {
		resultStream.write(s+JavaGenerator.NEWLINE);
		} catch(Exception ex) {
			Logger.getInstance().showError(ex);
		}
	}

	/* (non-Javadoc)
	 * @see jasco.util.StreamGobbler#showError(java.lang.String)
	 */
	public void showError(String s) {
		
		resultBuffer.append(s);
		try {
		resultStream.write(s+JavaGenerator.NEWLINE);
		}
		catch(Exception ex) {
			Logger.getInstance().showError(ex);
		}
	}

	/* (non-Javadoc)
	 * @see jasco.util.StreamGobbler#flush()
	 */
	public void flush() {

	}

}
