/*
 * Created on 23-mrt-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jasco.tools.aspectparser;

import jasco.runtime.transform.TransformerConstants;
import jasco.util.logging.Logger;
import javassist.CannotCompileException;
import javassist.CtClass;
import javassist.CtMethod;
import javassist.NotFoundException;
import javassist.expr.Cast;
import javassist.expr.ExprEditor;

/* 
 Copyright (C) 2002-2005 JAsCo Development Team
 http://ssel.vub.ac.be/jasco
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as
 published by the Free Software Foundation; either version 2 of the
 License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 USA 
 */

/**
 * @author Wim
 */

public class MixinCastImplementer {
	
	private CtClass mixinClass;
	private ClassFileEditor editor;
	
	public MixinCastImplementer(ClassFileEditor editor) {
		this.editor=editor;
		
		try {
			mixinClass=getEditor().loadClass("jasco.runtime.mixin.IMixin");
		} catch (NotFoundException e) {
			Logger.getInstance().showError(e);
		}
	}
	
	public ClassFileEditor getEditor() {
		
		return editor;
	}
	
	public void process() throws NotFoundException, CannotCompileException {
		
		CtClass clz = getEditor().getMainClass();
		CtMethod[] methods = clz.getDeclaredMethods();
		for(int i=0;i<methods.length;++i)
			if(TransformerConstants.addedByJAsCo(methods[i])||methods[i].getName().equals("mixinOf"))
				continue;
			else process(methods[i]);
	}

	/**
	 * @param method
	 * @throws CannotCompileException
	 */
	private void process(CtMethod method) throws CannotCompileException {
		
		method.instrument(new ExprEditor() {
		     public void edit(Cast cast) throws CannotCompileException {
		        try {
					//is it a mixin cast?
					if(!cast.getType().subtypeOf(mixinClass))
						return;
				} catch (NotFoundException e) {
					Logger.getInstance().showError(e);
				}
		        
		        String code = "";
		        code+="$_=($r) mixinOf($1, $type);";
		        cast.replace(code);
		     }
		 });
	}

}
