/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.tools.connectorparser;

import jasco.runtime.connector.MethodSignature;

import java.util.Iterator;
import java.util.Vector;

public class PCutpointDeclarationParameterInput
{
	public String type = null;
	public String classname = null;
	public String methodname = null;
	public Vector methodparameters = new Vector();
	private String annotationString = null;
	private int matchSubtypes=MethodSignature.NO_SUBTYPES;
	
	PCutpointDeclarationParameterInput()
	{
	}
	
	public void setType(String aType)
	{
		type = aType;
	}
	
	public String getType()
	{
		return type;
	} 
	
	public boolean hasAnnotation() {
		
		return annotationString!=null;
	}
	
	public void setAnnotation(String type) {
		
		annotationString=type;
	}
	
	public String getAnnotation() {
		
		return annotationString;
	}
	
	public void setClassName(String aClassName)
	{
		classname = aClassName;
	}
	
	public String getClassName()
	{
		return classname;
	}
	
	public void setMethodName(String aMethodName)
	{
		methodname = aMethodName;
	}
	
	public String getMethodName()
	{
		return methodname;
	}
	
	public void addMethodParameter(String aMethodParameter)
	{
		methodparameters.add(aMethodParameter);
	}
	
	public int getMethodParametersSize() 
	{
		return methodparameters.size();
	}
	
	public String getMethodParameter(int aIndex)
	{
		return (String)methodparameters.elementAt(aIndex);
	}
	
	public Vector getMethodParameters()
	{
		return methodparameters;
	}

	/**
	 * @param matchSubtypes
	 */
	public void matchSubtypes(int matchSubtypes) {
		this.matchSubtypes=matchSubtypes;
	}
	
	public int matchSubtypes() {
		
		return matchSubtypes;
	}
	
	public String generateMethodSignatureBuilder() {
		
		String result = "";
		
		result+="MethodSignature.build(";
		
		result+="\""+getType()+"\", ";
		result+="\""+getClassName()+"\", ";
		result+="\""+getMethodName()+"\", ";
		
		result+="new String[] {";
		Iterator i = methodparameters.iterator();
		while(i.hasNext()) {
			String next = (String) i.next();
			result+="\""+next+"\"";
			if(i.hasNext())
				result+=",";
		}
		result+="}, ";
		
		result+="new String[] {";
		if(this.hasAnnotation())
			result+="\""+this.getAnnotation()+"\"";
		result+="},"; 
		
		result+=this.matchSubtypes();
		result+=")";
		
		return result;
	}
}

