/*
 * Created on 18-mrt-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jasco.tools.connectorparser;

import jasco.options.Options;
import jasco.runtime.aspect.HookHelper;
import jasco.runtime.refinements.RefinementManager;
import jasco.tools.aspectparser.AspectClassesGenerator;
import jasco.util.generators.ClassGenerator;
import jasco.util.generators.JavaGenerator;
import jasco.util.generators.MethodGenerator;
import jasco.util.generators.VariableGenerator;

import java.lang.reflect.Modifier;
import java.util.Iterator;

/*  
 Copyright (C) 2002-2005 JAsCo Development Team
 http://ssel.vub.ac.be/jasco
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as
 published by the Free Software Foundation; either version 2 of the
 License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 USA 
 */

/**
 * @author Wim
 */

public class RefinableImplGenerator {

	private ClassGenerator global;
	
	public RefinableImplGenerator(ClassGenerator cg) {
		this.global=cg;
	}
	
	public ClassGenerator generateAbstractMethodImplemenations(String declname, Iterator methods, String hookClassName) throws RefinableMethodGenerationFailed
	{
		if(!methods.hasNext())
			return null;
		
		ClassGenerator refinableModule = new ClassGenerator("RefinableModule"+declname);
		refinableModule.addModifier(Modifier.STATIC);
		refinableModule.addModifier(Modifier.PUBLIC);
		refinableModule.setSuperClass("jasco.runtime.refinements.ConnectorInlineRefinement");
		MethodGenerator constructor = new MethodGenerator(refinableModule.getName(),"");
		constructor.addVariable("jasco.runtime.aspect.IHook","hook");
		constructor.setImplementation("super(hook,theImplementedMethods);");
		refinableModule.addMethod(constructor);
		
		VariableGenerator var = new VariableGenerator("Vector","theImplementedMethods");
		var.addModifier(Modifier.STATIC);
		var.setInitialiser("new Vector()");
		refinableModule.addVariable(var);
		
		String staticInitCode="";
		
		Class hookClass = null;
		
		try {
			hookClass=Options.loadClass(hookClassName);
		}catch(ClassNotFoundException ex) {
			
			throw new RefinableMethodGenerationFailed("hook class not found "+ex.getMessage());
		}
		 
		Iterator abstractmethods = methods;
		while(abstractmethods.hasNext()) {
			
			MethodGenerator methodimpl = (MethodGenerator) methods.next();
			int modifiers = methodimpl.getModifiers();
			modifiers = javassist.Modifier.setPublic(modifiers);
			methodimpl.setModifiers(modifiers);
			
			String methodname = methodimpl.getName();
			staticInitCode+=var.getName()+".add(\""+methodname+"\");"+JavaGenerator.NEWLINE;
			
			if(!HookHelper.isRefinableMethod(hookClass,methodimpl))
				throw new RefinableMethodGenerationFailed("refinable method "+methodname+" not declared in target hook");
			
			String jpname = AspectClassesGenerator.CONST_thisJoinPoint;
			String thisHookTemp = RefinementManager.THIS_HOOK+"_JasCo_2";
			
			methodimpl.insertVariable("jasco.runtime.MethodJoinpoint",jpname);
			methodimpl.insertVariable("jasco.runtime.aspect.IHook",thisHookTemp);
			refinableModule.addMethod(methodimpl);
			String code = methodimpl.getImplementation();
			if(!RefinementManager.THIS_HOOK.equals(declname))
				code=hookClassName+" "+declname+" = ("+hookClassName+")"+thisHookTemp+";"+JavaGenerator.NEWLINE+code;
			code=hookClassName+" "+RefinementManager.THIS_HOOK+" = ("+hookClassName+")"+thisHookTemp+";"+JavaGenerator.NEWLINE+code;
			code="Object "+AspectClassesGenerator.CONST_thisJoinPointObject+" = "+jpname+".getCalledObject()"+";"+JavaGenerator.NEWLINE+code;
			
			methodimpl.setImplementation(code);
		}
		
		refinableModule.addStaticInit(staticInitCode);
		
		global.addInnerClass(refinableModule);
	
		return refinableModule;	
	}

}
