/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.tools.gui;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Map;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.BevelBorder;
import javax.swing.border.TitledBorder;


public class MethodTreeNode extends AbstractTreeNode {
	
	private Hashtable methods;
	
	public MethodTreeNode(String name)  {
	
		super(name);
	}
	
	public void initInfoPanel(JPanel infoPanel)  {
		
		JLabel top = createTop("HookInstantiation "+getName());
		top.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED));
		
		JPanel center = new JPanel();
		center.setLayout(new BorderLayout());
		
		JPanel main = new JPanel();
		center.add("North",main);
		
		try {
		String s = getHookConstructor();
		JLabel constr = new JLabel("Constructor: ");
		JLabel val = new JLabel(s);
		
		main.add(constr);
		main.add(val);
		
		JPanel mappings = new JPanel();
		mappings.setBorder(new TitledBorder("Mappings defined in connector: "));
		center.add(mappings);
		
		mappings.setLayout(new GridLayout(getMethodHashtable().size(),1));
		
		Iterator i = getMethodHashtable().entrySet().iterator();
		while (i.hasNext())  {
			Map.Entry entry = (Map.Entry) i.next();
			String text = "arg"+entry.getKey();
			text+=" -> ";
			text+=entry.getValue();
			mappings.add(new JLabel(text));
		}
		}
		catch(Exception ex)  {
			System.err.println(ex.getMessage());
			ex.printStackTrace();
			JLabel error = new JLabel("Failed loading hook: "+getName());
			main.add(error);
		}
		
		
		
		
		infoPanel.add("North",top);	
		infoPanel.add(center);
	}
	
	public String getHookConstructor() throws Exception {

		HookTreeNode hook = (HookTreeNode)getParent();
		return hook.getHookConstructor();
		
	}
	
	public void setMethodHashtable(Hashtable map)  {
		
		methods=map;
	}
	
	public Hashtable getMethodHashtable()  {
	
		return methods;
	}
	

}
