/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.tools.jascoparser;

public class PImport 
{	
	public static final int SYNTHETIC = Integer.MIN_VALUE;
	
	private String importname = null;
	private int linenumber = 0;
	private boolean staticc = false;
	
	public PImport(String aImportName, int aLineNumber)
	{
		this(aImportName,aLineNumber,false);
	}
	
	public PImport(String aImportName, int aLineNumber, boolean staticc)
	{
		importname = aImportName;
		linenumber = aLineNumber;
		this.staticc=staticc;
	}
	
	public String getImportName() 
	{
		return importname;
	}
	
	public int getLineNumber()
	{
		return linenumber;
	}
	
	public void setImportName(String aImportName)
	{
		importname = aImportName;
	}
	
	public void setLineNumber(int aLineNumber)
	{
		linenumber = aLineNumber;
	}
	
	public boolean isStatic() {
		
		return staticc;
	}
	
	public String toString() {
		
		if(isSynthetic())
			return "";
		
		String res =  "import ";
		if(staticc)
			res+="static ";
		res+=getImportName();
		res+=";";
		res+=" //"+getLineNumber();
		return res;
	}

	public boolean isSynthetic() {
		return getLineNumber()==SYNTHETIC;
	}
}