/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
/*
 * Created on 26-nov-2004
 */
package jasco.util.javacompiler;

import jasco.options.Options;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;

/**
 * @author Wim
 */
public class DefaultJavaCompilerPlugin implements IJavaCompilerPlugin {

	/**
	 * 
	 */
	public DefaultJavaCompilerPlugin() {
		super();
	}
	
	public ICompileErrorParser getCompileErrorParser() {
		
		return new DefaultCompileErrorParser(); 
	}

	/* (non-Javadoc)
	 * @see jasco.util.javacompiler.IJavaCompilerPlugin#compile(java.lang.String, java.io.PrintWriter, java.io.PrintWriter)
	 */
	public void compile(String command, PrintWriter errorStream,
			PrintWriter outputStream) {
		
		try {
//		make new process
		Runtime runtime = Runtime.getRuntime();
		//TODO change heer!!!
		String javaCompiler = Options.getJavaCompiler();
	    
	 
		//System.out.println(command);
		final Process process = jasco.util.CommandRunner.getProcess(javaCompiler+" "+command);
		
		//read errorstream for compiler-errors
		BufferedReader reader = new BufferedReader(new InputStreamReader(process.getErrorStream()));
		String buffer = null;
		while ((buffer = reader.readLine()) != null)  
		{ 
			errorStream.write(buffer+Options.NEWLINE);
		}
		
		reader.close();
		
		}catch(java.io.IOException ex) {
			jasco.util.logging.Logger.getInstance().showError(ex);
		}

	}

}
